#include "timer.h"

Timer::Timer()
{
#ifdef WIN32
  QueryPerformanceFrequency(&m_freq);
#endif
}

Timer::~Timer()
{
}

void Timer::start()
{
#ifdef WIN32
  QueryPerformanceCounter(&m_start);
#elif defined LINUX
  clock_gettime (CLOCK_PROCESS_CPUTIME_ID, &m_start);
#endif
}

void Timer::stop()
{
#ifdef WIN32
  QueryPerformanceCounter(&m_end);
  m_dbSeconds = ((double)m_end.QuadPart - (double)m_start.QuadPart)/((double)m_freq.QuadPart);
#elif defined LINUX
  clock_gettime (CLOCK_PROCESS_CPUTIME_ID, &m_end);
  m_dbSeconds = (double)m_end.tv_sec + (double)m_end.tv_nsec/1000000000 -
                (double)m_start.tv_sec - (double)m_start.tv_nsec/1000000000;
#endif
}
